
#ifndef __SCREEN_H__
#define __SCREEN_H__
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
#define SCREEN_IMG_TAB_CNT				4

#define CURSOR_SPRITE_NO				512
#define CURSOR_TILE_NO_ARROW			514

//---------------------------------------------------------------------------

typedef struct {
	u16 x;
	u16 y;
	u16 buf[SCREEN_CX][SCREEN_CY] ALIGN(4);					//VideoBuffer̓p
} ST_SCREEN_IMG;


typedef struct {
	u16 x;
	u16 y;
	u16 sprNo;
	u16 tileNo;
	u8  blinkFlag;											//_ŗp̃tO
} ST_CURSOR;

//---------------------------------------------------------------------------
EWRAM_CODE void ScreenImgInit();
EWRAM_CODE void ScreenImgLoad();
EWRAM_CODE void ScreenImgClear();
EWRAM_CODE void ScreenImgUpdate();

EWRAM_CODE void ScreenImgNewLine();
EWRAM_CODE void ScreenImgSkipTab();

EWRAM_CODE void ScreenImgDrawStr(u8* str, u16 len);
EWRAM_CODE void ScreenImgDrawChr(u16 x, u16 y, u8 chr);
EWRAM_CODE void ScreenImgDrawNum(s32 var);

EWRAM_CODE void ScreenImgFadeIn(u16 mode, u16 min, u16 max, u16 wait);
EWRAM_CODE void ScreenImgFadeOut(u16 wait);

#ifdef __cplusplus
}
#endif
#endif
