
#ifndef __TASK_H__
#define __TASK_H__
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
#define TASK_MAX_REG_CNT			42			//128 / 3(؂̂)

#define SPR_MAX_CNT					128
#define SPR_CX						64
#define SPR_CY						32
#define SPR_MIKKU_STR1_TILENO		512			//݂݂ɂĂ`
#define SPR_MIKKU_STR2_TILENO		640			//݂݂ɂĂ`

//---------------------------------------------------------------------------

typedef struct {
	bool isReg;
	s16  x;
	s16  y;
	s16  cx;
	s16  cy;
	s16  xMove;
	u16  sprNo;
	u16  tileNo;
	bool isNext;
	void (*pAct)();
	void (*pMov)();
} ST_SPR;


typedef struct {
	u16    regCnt;
	u16    sprCnt;
	ST_SPR spr[SPR_MAX_CNT];
} ST_TASK;


//---------------------------------------------------------------------------
IWRAM_CODE void TaskInit();
IWRAM_CODE void TaskExec();
IWRAM_CODE void TaskInput();
IWRAM_CODE bool TaskIsSprAllFree();


IWRAM_CODE bool TaskIsFreeSpr();
IWRAM_CODE u16  TaskGetFreeSpr();

IWRAM_CODE void TaskRegSpr(u16 sprNo, u16 tileNo, s16 y, void* pAct, void* pMov);
IWRAM_CODE void TaskRegSpr2(u16 sprNo, u16 tileNo, s16 x, s16 y, void* pAct, void* pMov, s16 xMove);

//ANVf[^
IWRAM_CODE void TaskExecSprAct1(ST_SPR* p);
IWRAM_CODE void TaskExecSprAct2(ST_SPR* p);
IWRAM_CODE void TaskExecSprAct3(ST_SPR* p);

//ړf[^
IWRAM_CODE void TaskExecSprMov1(ST_SPR* p);

#ifdef __cplusplus
}
#endif
#endif
